QuantLib: MCAmericanEngine< RNG, S, RNG_Calibration > Class Template Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Member Functions | Protected Member Functions | List of all members
MCAmericanEngine< RNG, S, RNG_Calibration > Class Template Reference
Pricing engines » Vanilla option engines

American Monte Carlo engine. More...

`#include <ql/pricingengines/vanilla/mcamericanengine.hpp>`

Inheritance diagram for MCAmericanEngine< RNG, S, RNG_Calibration >:
[legend]

## Public Member Functions
| MCAmericanEngine (const ext::shared_ptr< GeneralizedBlackScholesProcess > &process, Size timeSteps, Size timeStepsPerYear, bool antitheticVariate, bool controlVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed, Size polynomOrder, LsmBasisSystem::PolynomType polynomType, Size nCalibrationSamples=Null< Size >(), const boost::optional< bool > &antitheticVariateCalibration=boost::none, BigNatural seedCalibration=Null< Size >())
void | calculate () const
Public Member Functions inherited from MCLongstaffSchwartzEngine< VanillaOption::engine, SingleVariate, PseudoRandom, Statistics, PseudoRandom >
| MCLongstaffSchwartzEngine (const ext::shared_ptr< StochasticProcess > &process, Size timeSteps, Size timeStepsPerYear, bool brownianBridge, bool antitheticVariate, bool controlVariate, Size requiredSamples, Real requiredTolerance, Size maxSamples, BigNatural seed, Size nCalibrationSamples=Null< Size >(), boost::optional< bool > brownianBridgeCalibration=boost::none, boost::optional< bool > antitheticVariateCalibration=boost::none, BigNatural seedCalibration=Null< Size >())
void | calculate () const
Public Member Functions inherited from McSimulation< SingleVariate, PseudoRandom, Statistics >
result_type | value (Real tolerance, Size maxSamples=QL_MAX_INTEGER, Size minSamples=1023) const
| add samples until the required absolute tolerance is reached
result_type | valueWithSamples (Size samples) const
| simulate a fixed number of samples
result_type | errorEstimate () const
| error estimated using the samples simulated so far
const stats_type & | sampleAccumulator () const
| access to the sample accumulator for richer statistics
void | calculate (Real requiredTolerance, Size requiredSamples, Size maxSamples) const
| basic calculate method provided to inherited pricing engines

## Protected Member Functions
ext::shared_ptr< LongstaffSchwartzPathPricer< Path > > | lsmPathPricer () const
Real | controlVariateValue () const
ext::shared_ptr< PricingEngine > | controlPricingEngine () const
ext::shared_ptr< PathPricer< Path > > | controlPathPricer () const
Protected Member Functions inherited from MCLongstaffSchwartzEngine< VanillaOption::engine, SingleVariate, PseudoRandom, Statistics, PseudoRandom >
virtual ext::shared_ptr< LongstaffSchwartzPathPricer< path_type > > | lsmPathPricer () const=0
TimeGrid | timeGrid () const
ext::shared_ptr< path_pricer_type > | pathPricer () const
ext::shared_ptr< path_generator_type > | pathGenerator () const
Protected Member Functions inherited from McSimulation< SingleVariate, PseudoRandom, Statistics >
| McSimulation (bool antitheticVariate, bool controlVariate)
virtual ext::shared_ptr< path_pricer_type > | controlPathPricer () const
virtual ext::shared_ptr< path_generator_type > | controlPathGenerator () const
virtual ext::shared_ptr< PricingEngine > | controlPricingEngine () const
virtual result_type | controlVariateValue () const

## Additional Inherited Members
Public Types inherited from MCLongstaffSchwartzEngine< VanillaOption::engine, SingleVariate, PseudoRandom, Statistics, PseudoRandom >
typedef SingleVariate< PseudoRandom >::path_type | path_type
typedef McSimulation< SingleVariate, PseudoRandom, Statistics >::stats_type | stats_type
typedef McSimulation< SingleVariate, PseudoRandom, Statistics >::path_pricer_type | path_pricer_type
typedef McSimulation< SingleVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type
typedef McSimulation< SingleVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type_calibration
Public Types inherited from McSimulation< SingleVariate, PseudoRandom, Statistics >
typedef MonteCarloModel< SingleVariate, PseudoRandom, Statistics >::path_generator_type | path_generator_type
typedef MonteCarloModel< SingleVariate, PseudoRandom, Statistics >::path_pricer_type | path_pricer_type
typedef MonteCarloModel< SingleVariate, PseudoRandom, Statistics >::stats_type | stats_type
typedef MonteCarloModel< SingleVariate, PseudoRandom, Statistics >::result_type | result_type
Static Protected Member Functions inherited from McSimulation< SingleVariate, PseudoRandom, Statistics >
static Real | maxError (const Sequence &sequence)
static Real | maxError (Real error)
Protected Attributes inherited from MCLongstaffSchwartzEngine< VanillaOption::engine, SingleVariate, PseudoRandom, Statistics, PseudoRandom >
ext::shared_ptr< StochasticProcess > | process_
const Size | timeSteps_
const Size | timeStepsPerYear_
const bool | brownianBridge_
const Size | requiredSamples_
const Real | requiredTolerance_
const Size | maxSamples_
const BigNatural | seed_
const Size | nCalibrationSamples_
const bool | brownianBridgeCalibration_
const bool | antitheticVariateCalibration_
const BigNatural | seedCalibration_
ext::shared_ptr< LongstaffSchwartzPathPricer< path_type > > | pathPricer_
ext::shared_ptr< MonteCarloModel< SingleVariate, PseudoRandom, Statistics > > | mcModelCalibration_
Protected Attributes inherited from McSimulation< SingleVariate, PseudoRandom, Statistics >
ext::shared_ptr< MonteCarloModel< SingleVariate, PseudoRandom, Statistics > > | mcModel_
bool | antitheticVariate_
bool | controlVariate_

## Detailed Description

### template<class RNG = PseudoRandom, class S = Statistics, class RNG_Calibration = RNG>
class QuantLib::MCAmericanEngine< RNG, S, RNG_Calibration >

American Monte Carlo engine.

References:

Tests:
  the correctness of the returned value is tested by reproducing results available in web/literature